



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
      
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.pipeline.stopwords" content="True">
      
        <meta name="lang:search.pipeline.trimmer" content="True">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.0.4, mkdocs-material-3.0.6">
    
    
      
        <title>Startup Scripts - QGIS + Python = ❤❤</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.451f80e5.css">
      
        <link rel="stylesheet" href="../assets/stylesheets/application-palette.22915126.css">
      
      
        
        
        <meta name="theme-color" content="#4caf50">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
    
    <link rel="stylesheet" href="../assets/fonts/material-icons.css">
    
    
  </head>
  
    
    
    <body dir="ltr" data-md-color-primary="green" data-md-color-accent="light-green">
  
    <svg class="md-svg">
      <defs>
        
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" data-md-component="overlay" for="__drawer"></label>
    
      <a href="#startup-scripts-using-python" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href=".." title="QGIS + Python = ❤❤" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="__drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                QGIS + Python = ❤❤
              </span>
              <span class="md-header-nav__topic">
                Startup Scripts
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="__search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="__search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="__drawer">
    <a href=".." title="QGIS + Python = ❤❤" class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </a>
    QGIS + Python = ❤❤
  </label>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href=".." title="Before We Start" class="md-nav__link">
      Before We Start
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../python_console/" title="The Python Console and editor" class="md-nav__link">
      The Python Console and editor
    </a>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="__toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="__toc">
        Startup Scripts
      </label>
    
    <a href="./" title="Startup Scripts" class="md-nav__link md-nav__link--active">
      Startup Scripts
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#using-code" title="Using --code" class="md-nav__link">
    Using --code
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-writing-the-startup-script" title="Exercise: Writing the startup script" class="md-nav__link">
    Exercise: Writing the startup script
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-adding-the-code-to-the-shortcut" title="Exercise: Adding the --code to the shortcut" class="md-nav__link">
    Exercise: Adding the --code to the shortcut
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#using-startuppy" title="Using startup.py" class="md-nav__link">
    Using startup.py
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-finding-the-startuppy" title="Exercise: Finding the startup.py" class="md-nav__link">
    Exercise: Finding the startup.py
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-editing-the-startuppy-file" title="Exercise: Editing the startup.py file" class="md-nav__link">
    Exercise: Editing the startup.py file
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#pyqgis_startup" title="PYQGIS_STARTUP" class="md-nav__link">
    PYQGIS_STARTUP
  </a>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
    
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../expression_functions/" title="Custom Expression Functions" class="md-nav__link">
      Custom Expression Functions
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../processing/" title="Processing Scripts" class="md-nav__link">
      Processing Scripts
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../project_macros/" title="Project Macros" class="md-nav__link">
      Project Macros
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../bonus/" title="Bonus Round!!" class="md-nav__link">
      Bonus Round!!
    </a>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#using-code" title="Using --code" class="md-nav__link">
    Using --code
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-writing-the-startup-script" title="Exercise: Writing the startup script" class="md-nav__link">
    Exercise: Writing the startup script
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-adding-the-code-to-the-shortcut" title="Exercise: Adding the --code to the shortcut" class="md-nav__link">
    Exercise: Adding the --code to the shortcut
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#using-startuppy" title="Using startup.py" class="md-nav__link">
    Using startup.py
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-finding-the-startuppy" title="Exercise: Finding the startup.py" class="md-nav__link">
    Exercise: Finding the startup.py
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-editing-the-startuppy-file" title="Exercise: Editing the startup.py file" class="md-nav__link">
    Exercise: Editing the startup.py file
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#pyqgis_startup" title="PYQGIS_STARTUP" class="md-nav__link">
    PYQGIS_STARTUP
  </a>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                
                <h1 id="startup-scripts-using-python">Startup Scripts using Python</h1>
<p><strong>API Note:</strong> Any QGIS APIs referenced will link out to the <a href="https://qgis.org/pyqgis/master">Python API Docs</a>.</p>
<p>Startup scripts a great way to tweak what happens to QGIS on startup. This startup scripts have access to the full QGIS API and Python so are able to do generally
anything that is needed to customize an environment.</p>
<p>QGIS has three places it can use Python on start up.</p>
<p>They are:</p>
<ul>
<li><code>--code</code> command line option</li>
<li><code>startup.py</code> in the root app data folder for QGIS</li>
<li><code>PYQGIS_STARTUP</code> environment variable</li>
</ul>
<h3 id="using-code">Using <code>--code</code></h3>
<h4 id="exercise-writing-the-startup-script">Exercise: Writing the startup script</h4>
<p>Use the script editor and create a new file with the following code using 
<a href="https://qgis.org/pyqgis/master/gui/Message/QgsMessageBar.html#qgis.gui.QgsMessageBar.pushMessage">QgsMessageBar.pushMessage</a> 
to push the message on the message bar.</p>
<pre><code>from qgis.utils import iface

iface.messageBar().pushMessage(&quot;FOSS4G&quot;, &quot;FOSS4G for the win!&quot;)
</code></pre>

<p>Run the script and you can see the message.  If we need it to stick there we can use:</p>
<pre><code>from qgis.utils import iface

iface.messageBar().pushMessage(&quot;FOSS4G&quot;, &quot;FOSS4G for the win!&quot;,duration=0)
</code></pre>

<p>We will save this script using the save button e.g  <code>C:\temp\workshop\code-startup.py</code></p>
<h4 id="exercise-adding-the-code-to-the-shortcut">Exercise: Adding the <code>--code</code> to the shortcut</h4>
<p>Take a copy of the QGIS shortcut and add the following:</p>
<pre><code> --code &quot;C:\temp\workshop\code-startup.py&quot;
</code></pre>

<p>The full shortcut should look like this:</p>
<p><img alt="Function Editor" src="../img/shortcut.png" /></p>
<p>Load QGIS using the new shortcut.</p>
<p><img alt="Function Editor" src="../img/banner.png" /></p>
<h3 id="using-startuppy">Using <code>startup.py</code></h3>
<p>The next example is using <code>startup.py</code></p>
<p><code>startup.py</code> is loaded from the app data folder for QGIS.</p>
<h4 id="exercise-finding-the-startuppy">Exercise: Finding the startup.py</h4>
<p>We can find the app data folder for QGIS using <code>User Profiles -&gt; Open Active Profile Folder</code></p>
<p>This will open the current profile folder for you at:</p>
<pre><code>C:\Users\YOURUSER\AppData\Roaming\QGIS\QGIS3\profiles\default
</code></pre>

<p>However <code>startup.py</code> will live in <code>C:\Users\YOURUSER\AppData\Roaming\QGIS\QGIS3</code> as it is used by all profiles.</p>
<h4 id="exercise-editing-the-startuppy-file">Exercise: Editing the startup.py file</h4>
<p>Create a empty text file there called <code>startup.py</code></p>
<p><img alt="Function Editor" src="../img/startup.png" /></p>
<p>Open the script in the function editor and load that file:</p>
<p><img alt="Function Editor" src="../img/startup_loaded.png" /></p>
<p>Now enter the following:</p>
<pre><code>iface.messageBar().pushMessage(&quot;FOSS4G&quot;, &quot;Hello From Start Up&quot;, duration=0)
</code></pre>

<p>Save the file and load a new copy of QGIS. (<strong>Note</strong>: Not the one with the extra <code>--code</code> option from before)</p>
<p><img alt="Function Editor" src="../img/startup_banner.png" /></p>
<h2 id="pyqgis_startup"><code>PYQGIS_STARTUP</code></h2>
<p>This one is a bit more advanced as it happens before any of the QGIS libraries are loaded and it's use case is limited.
It included here to highlight it as a option but it's use case is limited.</p>
                
                  
                
              
              
                


              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../python_console/" title="The Python Console and editor" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                The Python Console and editor
              </span>
            </div>
          </a>
        
        
          <a href="../expression_functions/" title="Custom Expression Functions" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Custom Expression Functions
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.5e60981f.js"></script>
      
      <script>app.initialize({version:"1.0.4",url:{base:".."}})</script>
      
    
    
      
    
  </body>
</html>